// ============================================================
// UTPureRC5w.PureInfo: put your comment here

// Created by UClasses - (C) 2000 by meltdown@thirdtower.com
// ============================================================

class PureInfo expands Info;

var float zzLastTick;
var int zzTickOff;
var int zzPlayerCalcViewCalls;

struct WeaponShakeFix {
	var class<Weapon> zzWeaponClass;
	var float zzShakeMag,zzShakeTime,zzShakeVert;
};

var private WeaponShakeFix WeaponFixes[10];

event Tick(float zzdelta)
{
	if (zzDelta <= 0.0)
		return;
	zzLastTick += zzdelta;
	zzTickOff--;
	zzPlayerCalcViewCalls = 1;
}

function xxInstallSpawnNotify(PlayerPawn zzPP)
{
	local PureSN zzPSN;
	local SpawnNotify zzSN,zzSNLast;

	for (zzSN = zzPP.Level.SpawnNotify; zzSN != None; zzSN = zzSN.Next)
	{
		if (zzSN.IsA('PureSN'))
		{
			if (zzSN.Next != None)
				bbPlayer(zzPP).xxServerCheater("S1");
//			Log("ISN: Already In");
			return;
		}
		zzSNLast = zzSN;
	}

	zzSN = zzPP.Level.SpawnNotify;
	Level.SpawnNotify = None;
	zzPSN = zzPP.Level.Spawn(Class'PureSN',zzPP);
	zzPSN.Next = None;
	if (zzSNLast == None)
		zzPP.Level.SpawnNotify = zzPSN;
	else
	{
		zzSNLast.Next = zzPSN;
		zzPP.Level.SpawnNotify = zzSN;
	}
//	Log("ISN: Installed");
}

function xxStartupCheck(PlayerPawn zzPP)
{
	local actor zzA;

//	Log("Level.AllActors");
	ForEach zzPP.Level.AllActors(Class'Actor',zzA)
	{
		xxSetClassDefault(zzA.Class);
		xxSetClass(zzA);
	}
//	Log("EntryLevel.AllActors");
	ForEach zzPP.GetEntryLevel().AllActors(Class'Actor',zzA)
	{
		xxSetClassDefault(zzA.Class);
		xxSetClass(zzA);
	}

}

static function xxSetClassDefault(Class<Actor> zzA)
{
	local int zzx;
	local Class<Weapon> zzcW;

//	Log("SCD:"@zzA);
	if (ClassIsChildOf(zzA,Class'Pickup'))
	{
		zzA.default.bUnlit = False;
	}

	if (ClassIsChildOf(zzA,Class'Effects'))
	{
		zzA.default.bHidden = False;
	}

	if (ClassIsChildOf(zzA,Class'PlayerStart'))
	{
		zzA.default.bHidden = True;
	}

	if (ClassIsChildOf(zzA,Class'Carcass'))
	{
		zzA.default.bHidden = False;
	}

	if (ClassIsChildOf(zzA,Class'Weapon'))
	{
//		Log(zzA@"is a weapon");
		zzcW = Class<Weapon>(zzA);
		for (zzx = 0; zzx < 10; zzx++)
		{
			if (Default.WeaponFixes[zzx].zzWeaponClass == zzcW)
			{
//				log("dFixing"@zzcW@zzcW.Default.ShakeMag@zzcW.Default.ShakeTime@zzcW.Default.ShakeVert);
				zzcW.Default.ShakeMag = Default.WeaponFixes[zzx].zzShakeMag;
				zzcW.Default.ShakeTime = Default.WeaponFixes[zzx].zzShakeTime;
				zzcW.Default.ShakeVert = Default.WeaponFixes[zzx].zzShakeVert;
//				log("dPost Fixing"@zzcW@zzcW.Default.ShakeMag@zzcW.Default.ShakeTime@zzcW.Default.ShakeVert);
			}
		}
	}

}

static function xxSetClass(Actor zzA)
{
	local int zzx;
	local Weapon zzW;

//	Log("SC:"@zzA);
	if (ClassIsChildOf(zzA.Class,Class'Pickup'))
	{
		zzA.bUnlit = False;
	}

	if (ClassIsChildOf(zzA.Class,Class'Effects'))
	{
		zzA.bHidden = False;
	}

	if (ClassIsChildOf(zzA.Class,Class'PlayerStart'))
	{
		zzA.bHidden = True;
	}

	if (ClassIsChildOf(zzA.Class,Class'Carcass'))
	{
		zzA.bHidden = False;
	}

	if (ClassIsChildOf(zzA.Class,Class'Weapon'))
	{
//		Log(zzA@"is a weapon");
		zzW = Weapon(zzA);
		for (zzx = 0; zzx < 10; zzx++)
		{
			if (Default.WeaponFixes[zzx].zzWeaponClass == zzW.Class)
			{
//				log("Fixing"@zzW.Class@zzW.ShakeMag@zzW.ShakeTime@zzW.ShakeVert);
				zzW.ShakeMag = Default.WeaponFixes[zzx].zzShakeMag;
				zzW.ShakeTime = Default.WeaponFixes[zzx].zzShakeTime;
				zzW.ShakeVert = Default.WeaponFixes[zzx].zzShakeVert;
//				log("Post Fixing"@zzW.Class@zzW.ShakeMag@zzW.ShakeTime@zzW.ShakeVert);
			}
		}
	}
}

defaultproperties {
	WeaponFixes(0)=(zzWeaponClass=Class'minigun2',zzShakeMag=135.0,zzShakeTime=0.10,zzShakeVert=8.0)
	WeaponFixes(1)=(zzWeaponClass=Class'enforcer',zzShakeMag=200.0,zzShakeTime=0.10,zzShakeVert=4.0)
	WeaponFixes(2)=(zzWeaponClass=Class'PulseGun',zzShakeMag=135.0,zzShakeTime=0.10,zzShakeVert=8.0)
	WeaponFixes(3)=(zzWeaponClass=Class'ripper',zzShakeMag=120.0,zzShakeTime=0.10,zzShakeVert=5.0)
	WeaponFixes(4)=(zzWeaponClass=Class'ShockRifle',zzShakeMag=300.0,zzShakeTime=0.10,zzShakeVert=5.0)
	WeaponFixes(5)=(zzWeaponClass=Class'SniperRifle',zzShakeMag=500.0,zzShakeTime=0.15,zzShakeVert=8.0)
	WeaponFixes(6)=(zzWeaponClass=Class'ut_biorifle',zzShakeMag=300.0,zzShakeTime=0.10,zzShakeVert=5.0)
	WeaponFixes(7)=(zzWeaponClass=Class'UT_Eightball',zzShakeMag=350.0,zzShakeTime=0.20,zzShakeVert=7.5)
	WeaponFixes(8)=(zzWeaponClass=Class'UT_FlakCannon',zzShakeMag=350.0,zzShakeTime=0.15,zzShakeVert=8.5)
	WeaponFixes(9)=(zzWeaponClass=Class'ImpactHammer',zzShakeMag=300.0,zzShakeTime=0.10,zzShakeVert=5.0)
}
