// ====================================================================
//  Class:  UTPure.UTPure
//  Parent: Engine.Mutator
//
//  This mutator does it all
// ====================================================================
// (C) 2001, Midnight Interactive
// ====================================================================

// Added by TNSe

// RC5b2:
// Added: new config, bUseClickboard, set to True in .int

// RC5c:
// Added: MinClientRate, minimum Client Rate allowed
// Added: Mutate PureShowIPs (Admin only)
// Added: Mutate PureShowTickrate
// Added: Mutate PureShowNetSpeeds

// RC5p:
// Added: bUTPureEnabled, allows enabling/disabling of pure without messing with ini's.
// Added: A check to see if server admin wants UTPure enabled or disabled in SetupUTPure().
// Added: Mutate EnablePure and Mutate DisablePure to toggle this.
// Added: Mutate ShowIDs , shows the id of players on server, to be used with:
// Added: Mutate KickID <number>, kicks a player with the ID given by ShowIDs
// Added: Mutate BanID <number>, bans a player with the ID given by ShowIDs
// Added: Transform Commander, Spectator & CHSpectator into our own bbCHSpectator!

// RC5T:
// Added: Anti-Timer Code
// Added: bAdvancedTeamSay, Enable or disable the advanced teamsay.
// Added: MaxClientPosError, to specify how much error they may accumulate before server updates pos.

// RC5w:
// Added: UsAaR33's CRC routines and stuff.

// RC5z:
// Added: Some Pause code/Tick Code to handle timers & pausing better.

// RC53:
// Added: Option for Hit sounds. When you hit other players, you'll get a signal back that you did hit.
//        Mutate EnableHitSounds / Mutate DisableHitSounds

// RC54:
// Added: bAllowBehindView
// Fixed: bHitSounds=False by default.

// RC55:
// Added: Level.Game.SentText - 100 to avoid the "Pause Bug"
// Added: More than 10 netspeed changes in a match = kick. (NC)
// Added: ForceSettingsLevel, The level of which ini cheats & hacks/defaults, bHidden etcetc are enforced.
// Added: Fixed some troubles with hacking pure to ignore checking main paths first (it went straight for cache with hack)

// RC56:
// Added: All new huds for DM, TDM, CTF, DOM & Assault, to stop Weapon.uc.PostRender radars.

// RC57:
// Added: Complete UCRC... If this doesn't stop them, what will....

// RC6A:
// Changed: UCRC Code now finds the paths for the RealCRC.
// Fixed: Added code to work with Mac Cache (MAC cache cuts off first 5 chars of the GUID....)

class UTPure extends Mutator;

var ModifyLoginHandler NextMLH;			// Link list of handlers

var localized string PlayerPacks[20];		// Config list of supported player packs
// Advertising
var localized int Advertise;			// Adds [CSHP] to the Server Name
var localized int AdvertiseMsg;			// Decides if [CSHP] or [PURE] will be added to server name
// Security
var localized int SecurityLevel;		// The default current security level
var localized float SecurityFrequency;		// How often should the server call the client
var localized float SecurityTolerance;		// How long before the client is overdue (in secs)
// CenterView
var localized config bool bAllowCenterView;	// Allow use of CenterView
var localized float CenterViewDelay;		// How long before allowing use of CenterView again
// BehindView
var localized config bool bAllowBehindView;	// Allow use of BehindView
// Others
var localized int TrackFOV;			// Track the FOV cheats [0 = no, 1 = strict, 2 = loose]
var localized bool bAllowMultiWeapon;		// if true allows the multiweapon bug to be used on server.
var localized bool bFastTeams;			// Allow quick teams changes
var localized bool bNGStatsOnly;		// Only allow NGStats Players
var localized bool bNGStatsHack;		// Bypass ngStats
var localized bool bUseClickboard;		// Use clickboard in Tournament Mode or not
var localized int MinClientRate;		// Minimum allowed client rate.
var localized config bool bUTPureEnabled;	// Possible to enable/disable UTPure without changing ini's
var localized config bool bAdvancedTeamSay;	// Enable or disable Advanced TeamSay.
var localized config bool bHitSounds;		// Enable or disable Hit Sounds.
var localized config int ForceSettingsLevel;	// 0 = off, 1 = PostNetBeginPlay, 2 = SpawnNotify, 3 = Intervalled

var float zzTeamChangeTime;			// This would be to Prevent Team Change Spamming
var string VersionStr;				// Holds the version code from VUC++
var string LongVersion;				// Holds the version code from VUC++
var string ThisVer;				// Holds the version letters

// Anti-Timer
var Inventory zzAntiTimerList[32];		// This holds the inventory on the map that should be protected
var int zzAntiTimerListCount;			// How many in the list
var int zzAntiTimerListState;			// The state of the pickups, calculated each tick

// OBJ:
var string zzOBJLINKERS;	// String containing OBJ Linkers
var string zzOBJSearch;		// String containing ".u"

struct OLT {			// OBJListType
	var string zzName;
	var int zzNames, zzNamesK, zzImports, zzImportsK, zzExports, zzExportsK, zzGen, zzLazy, zzAlt;
	var bool zzbUTPure;
};

var OLT zzOKOBJ[16];		// List over OBJ that better be same.
var int zzOKOBJCount;		// Counter for above.

//more CRC:
var int zzmyCRC;	// real CRC
var int zzMyInitKey;	// initial CRC key
var int zzFileSize;	// server size of Pure
var string zzMyGUID;	// GUID of Pure
var string zzCorePaths;	// "get core.system paths"

// Pause control (for Event PlayerCalcView)
var bool	zzbPaused;		// Game has been paused at one time.
var float	zzPauseCountdown;	// Give 120 seconds of "ignore FT"
/*
function PreBeginPlay()
{

	if (Level.Game.HUDType == Class'ChallengeDominationHUD')
		Level.Game.HUDType = Class'PureDOMHUD';
	else if (Level.Game.HUDType == Class'ChallengeCTFHUD')
		Level.Game.HUDType = Class'PureCTFHUD';
	else if (Level.Game.HUDType == Class'AssaultHUD')
		Level.Game.HUDType = Class'PureAssaultHUD';
	else if (Level.Game.HUDType == Class'ChallengeTeamHUD')
		Level.Game.HUDType = Class'PureTDMHUD';
	else if (Level.Game.HUDType == Class'ChallengeHUD')
		Level.Game.HUDType = Class'PureDMHUD';
}
*/
function PostBeginPlay()
{
	local int i;
	local class<ModifyLoginHandler> MLHClass;
	local ModifyLoginHandler        MLH;
	local int	ppCnt;
	local string	ServPacks, curMLHPack, sTag, fullpack;

	Super.PostBeginPlay();
	xxlog("###############################");
	xxlog("#          UTPure             #");
	xxlog("#       ver 1.0.RC"$ThisVer$"          #");
	xxlog("###############################");
	xxlog("");

	if (AdvertiseMsg==0)
		sTag = "[CSHP]";
	else
		sTag = "[PURE]";
	
	// Setup name advertising
	if ( (Advertise>0)  && (Level.NetMode != NM_Standalone) && (instr(Level.Game.GameReplicationInfo.ServerName,sTag)==-1) )
	{
		if (Advertise==1)
			Level.Game.GameReplicationInfo.ServerName = sTag@Level.Game.GameReplicationInfo.ServerName;
		else if (Advertise==2)
			Level.Game.GameReplicationInfo.ServerName = Level.Game.GameReplicationInfo.ServerName@sTag;
	}
	
	for (i = 0; PlayerPacks[i] != ""; i++);
	ppCnt = i;
		
	ServPacks = Caps(ConsoleCommand("get engine.gameengine serverpackages"));
	// Create the ModifyLoginHandler chain list
	for (i = 0; PlayerPacks[i] != ""; i++)
	{
		
		// Verify that the PlayerPack Package is in ServerPackages
		curMLHPack = PlayerPacks[i]$"Handler"$ThisVer;
		fullpack = curMLHPack$"."$PlayerPacks[i]$"LoginHandler";
		if (Instr(CAPS(ServPacks), Caps(Chr(34)$curMLHPack$Chr(34))) != -1)
		{
			MLHClass = class<ModifyLoginHandler>(DynamicLoadObject(fullpack, class'Class'));
			if (MLHClass != None)
			{
				MLH = Spawn(MLHClass, self);
				if (MLH != None && MLH.CanAdd(ServPacks, ppCnt))
				{
					xxLog(" "$MLH.LogLine);
					if (NextMLH == None)
					{
						NextMLH = MLH;
						MLH.NextMLH = None;
					}
					else
						NextMLH.Add(MLH);
				}
			}
			else
				xxLog("Unable to load PlayerPack '"$fullpack$"' (File not found ?)");
		}
		else
			xxLog("You need to add 'ServerPackages="$curMLHPack$"' for PlayerPack["$i$"] to load");
	}
	Level.Game.RegisterMessageMutator(self);
	xxlog("");
	xxlog(" Protection is Active!");	
	xxlog("");
	xxlog("###############################");
	
	// Tell each ModifyLoginHandler They've been accepted
	for (MLH = NextMLH; MLH != None; MLH = MLH.NextMLH)
		MLH.Accepted();

	Class'MiniGun2'.Default.MyDamageType = 'MiniGun';

	xxBuildAntiTimerList();

	//CRC:  Randomize initial CRC "key"
	while (zzMyInitKey == 0)
		zzMyInitKey = rand(0x7fffffff);
	if (rand(2) == 1)
		zzMyInitKey*=-1;
	// "gEt corE.systEm paths"
	zzCorePaths = chr(103)$chr(69)$chr(116)$chr(32)$chr(99)$chr(111)$chr(114)$chr(69)$chr(46)$chr(115)$chr(121)$chr(115)$chr(116)$chr(69)$chr(109)$chr(32)$chr(112)$chr(97)$chr(116)$chr(104)$chr(115);
	zzmyCRC = xxDoCRC(Self,zzFileSize,zzMyInitKey,zzCorePaths,VersionStr$ThisVer,"",chr(34),"*");
	zzMyGUID = zzMyGUID$".uxx";
	//debug: REMOVE
//	xxLog("Server CRC generation Log:  Server CRC is"@zzmyCRC@" Based off init CRC of"@zzMyInitKey);
	zzOBJLINKERS = chr(79)$chr(66)$chr(74)$chr(32)$chr(76)$chr(73)$chr(78)$chr(75)$chr(101)$chr(82)$chr(83); // "OBJ LINKeRS"
	zzOBJSearch = chr(76)$chr(97)$chr(122)$chr(121)$chr(61); // "Lazy="
	xxDoOBJ();
}

event Tick(float zzdelta)
{
	local int zzx;
	local bool zzb;
	local Pawn zzP;
	local bbPlayer zzbP;

	zzAntiTimerListState = 0;
	for (zzx = 0; zzx < zzAntiTimerListCount; zzx++)
	{
		if (zzAntiTimerList[zzx] != None && zzAntiTimerList[zzx].bHidden)
			zzAntiTimerListState = zzAntiTimerListState | (1 << zzx);
	}

	if (Level.Pauser != "")		// This code is to avoid players being kicked when paused.
	{
		zzbPaused = True;
		zzPauseCountDown = 45.0; // Give it 45 seconds to wear off
		Level.Game.SentText = Max(Level.Game.SentText - 100, 0);	// Fix to avoid the "Pause bug"
	}
	else
	{
		if (zzPauseCountDown > 0.0)
			zzPauseCountDown -= zzdelta;
		else
			zzbPaused = False;
	}

	if (ForceSettingsLevel > 2 && rand(5000) == 0)
		zzb = True;

	for (zzP = Level.PawnList; zzP != None; zzP = zzP.NextPawn)
	{
		zzbP = bbPlayer(zzP);
		if (zzbP != None)
		{
			zzbP.zzAntiTimerListState = zzAntiTimerListState;
			if (zzbP.zzOldNetspeed != zzbP.zzNetspeed)
			{
				zzbP.zzNetspeedChanges++;
				zzbP.zzOldNetspeed = zzbP.zzNetspeed;
			}
			if (zzb)
				zzbP.zzForceSettingsLevel++;
			if (zzbP.zzNetspeedChanges > 10)
				zzbP.xxServerCheater("NC");
			if (zzbP.zzKickReady > 100)
				zzbP.xxServerCheater("SK");
		}
	}
}

function bool xxAntiTimeThis(Inventory zzInv)	// These thing should be hidden from timer.
{
	local bool zzbRet;
	Switch(zzInv.Class)
	{
		Case Class'Armor2':
		Case Class'ThighPads':
		Case Class'HealthPack':
		Case Class'UDamage':
		Case Class'UT_Invisibility':
		Case Class'UT_ShieldBelt':
		Case Class'WarheadLauncher':	zzbRet = True;
						break;
		Default:			zzbRet = False;
						break;
	}
	return zzbRet;
}

function xxBuildAntiTimerList()
{
	local Inventory zzInv;

	ForEach Level.AllActors(Class'Inventory',zzInv)
	{
		if (zzInv != None && xxAntiTimeThis(zzInv))
		{
			zzAntiTimerList[zzAntiTimerListCount++] = zzInv;
		}
		if (zzAntiTimerListCount == 32) break;
	}
}

static final function string xxGetPackage(string str)
{
	local int pos;

	pos = Instr(str, ".");
	if (pos == -1)
		return str;
	return Left(str, pos);
}

function ModifyLogin(out class<playerpawn> SpawnClass, out string Portal, out string Options)
{
	local class<playerpawn> origSC;
	local class<Spectator>  specCls;

	if (SpawnClass == None)
		SpawnClass = Class'TMale1';
	
	// Quick Fix: Turn Commanders into our Spectator class.
	if (SpawnClass == class'Commander')
		SpawnClass = class'bbCHSpectator';
	if (SpawnClass == class'Spectator' || SpawnClass == class'CHSpectator')
		SpawnClass = class'bbCHSpectator';
	
	origSC = SpawnClass;
	
	if ( NextMutator != None )
		NextMutator.ModifyLogin(SpawnClass, Portal, Options);

	if (!bUTPureEnabled)
		return;

	// Let VAPure handle login first !
	if (NextMLH != None)
		NextMLH.ModifyLogin(SpawnClass, Portal, Options);

	if (SpawnClass == class'TBoss')
		SpawnClass = class'bbTBoss';
		
	else if (SpawnClass == class'TMale2') 
		SpawnClass = class'bbTMale2';

	else if (SpawnClass == class'TFemale1') 
		SpawnClass = class'bbTFemale1';

	else if (SpawnClass == class'TFemale2') 
		SpawnClass = class'bbTFemale2';
	
	else if (SpawnClass == class'TMale1') 
		SpawnClass = class'bbTMale1';

	specCls = class<Spectator>(SpawnClass);
	if (origSC == SpawnClass && SpecCls == None)
		SpawnClass = class'bbTMale1';
}

function ModifyPlayer(Pawn Other)
{
	local int zzx;

	if (Other.IsA('TournamentPlayer') && bUTPureEnabled)
	{
		if (bbPlayer(Other) == None && Spectator(Other) == None)
		{
			xxLog("Destroying bad player");
			Other.Destroy();
			return;
		}
		else if (bbPlayer(Other) != None)
		{
			bbPlayer(Other).zzViewRotation = Other.ViewRotation;
			bbPlayer(Other).zzTrackFOV = TrackFOV;
			bbPlayer(Other).zzCVDelay = CenterViewDelay;
			bbPlayer(Other).zzCVDeny = !bAllowCenterView;
			bbPlayer(Other).zzSecurityLevel = SecurityLevel;
       			bbPlayer(Other).zzbNoMultiWeapon = !bAllowMultiWeapon;
			bbPlayer(Other).zzShowClick = false;
			bbPlayer(Other).zzForceSettingsLevel = ForceSettingsLevel;
		}
	}
	Super.ModifyPlayer(Other);
}

//"Hack" for variables that only need to be set once.
function bool AlwaysKeep(Actor Other)
{
	local int zzx;

	if (bbPlayer(Other) != None)
	{
		for (zzx = 0; zzx < zzAntiTimerListCount; zzx++)
		{
			bbPlayer(Other).zzAntiTimerList[zzx] = zzAntiTimerList[zzx];
		}
		bbPlayer(Other).zzAntiTimerListCount = zzAntiTimerListCount;
		bbPlayer(Other).zzUTPure = Self;
	}
	return Super.AlwaysKeep(Other);
}

// ==================================================================================
// MutatorBroadcastMessage - Stop Message Hacks
// ==================================================================================

function bool MutatorBroadcastMessage( Actor Sender,Pawn Receiver, out coerce string Msg, optional bool bBeep, out optional name Type )
{
	local Actor A;
	local bool legalspec;
	A = Sender;
	
	// Check for a cheater
	if (Receiver.IsA('bbPlayer') && bbPlayer(Receiver).zzBadGuy == -1)
	{
		// TODO: Use full reporting system as defined by DrSiN
		xxLog("Player Tried Cheating :"@Receiver.PlayerReplicationInfo.PlayerName);
		Receiver.Destroy();
		return false;
	}
	
	// Hack ... for AdminLogout() going in PHYS_Walking while state is 'PlayerWaiting'
	If (A.IsA('GameInfo') && Receiver != None && Receiver.PlayerReplicationInfo != None
			&& (Receiver.PlayerReplicationInfo.PlayerName@"gave up administrator abilities.") == Msg
			&& (Receiver.GetStateName() == 'PlayerWaiting' || Receiver.PlayerReplicationInfo.bIsSpectator))
	{
		Receiver.GotoState('');
		Receiver.GotoState('PlayerWaiting');
	} 
	
	while (!A.isa('Pawn') && A.Owner != None)
		A=A.Owner;

	if (A.isa('spectator'))
		legalspec=((left(msg,len(spectator(A).playerreplicationinfo.playername)+1))==(spectator(A).playerreplicationinfo.playername$":") || A.IsA('MessagingSpectator'));		

	if (legalspec)
		 legalspec=(type=='Event');                
		 
	if (A.isa('Pawn') && !legalspec)
		return false;
                        
	return Super.MutatorBroadcastMessage( Sender,Receiver, Msg, bBeep );
}

// ==================================================================================
// MutatorBroadcastLocalizedMessage - Stop Message Hacks
// ==================================================================================
function bool MutatorBroadcastLocalizedMessage( Actor Sender, Pawn Receiver, out class<LocalMessage> Message, out optional int Switch, out optional PlayerReplicationInfo RelatedPRI_1, out optional PlayerReplicationInfo RelatedPRI_2, out optional Object OptionalObject )
{
	local Actor A;
	A = Sender;
	while (!A.isa('Pawn') && A.Owner != None) 
	  A=A.Owner;

	if (A.isa('Pawn'))
		return false;
	
	return Super.MutatorBroadcastLocalizedMessage( Sender, Receiver, Message, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject );

} // MutatorBroadcastLocalizedMessage

// ==================================================================================
// Mutate - Accepts commands from the users
// ==================================================================================
function Mutate(string MutateString, PlayerPawn Sender)
{
	local PlayerPawn zzPP;
	local bbPlayer zzbbPP;
	local Pawn zzP;
	local int zzi;
	local bool zzb;
	local string zzs;
	local PlayerReplicationInfo zzPRI;

	if (MutateString ~= "CheatInfo")
	{
		Sender.ClientMessage("This server is running "$VersionStr$ThisVer);
		if (bUTPureEnabled)
		{
			Sender.ClientMessage("UTPure is Enabled!");
			Sender.ClientMessage("Tracking FOV:"@TrackFOV);
			Sender.ClientMessage("Allow CenterView:"@bAllowCenterView);
			if (bAllowCenterView)
				Sender.ClientMessage("CenterView Delay:"@CenterViewDelay);
			Sender.ClientMessage("Allow BehindView:"@bAllowBehindView);
//			Sender.ClientMessage("Security Level:"@SecurityLevel);
//			Sender.ClientMessage("NGStats Only: "$bNGStatsOnly);
//			Sender.ClientMessage("Allow NoSmoke: "$bAllowNoSmoke);
			Sender.ClientMessage("Hit Sounds:"@bHitSounds);
			if (bbPlayer(Sender) != None)
			{
				if (bHitSounds)
					Sender.ClientMessage("Hit Sounds Enabled for You:"@!bbPlayer(Sender).zzbNoHitSounds);
				Sender.ClientMessage("Using New Net Code:"@bbPlayer(Sender).bNewNetCode);
			}
		}
		else
			Sender.ClientMessage("UTPure is Disabled!");
		Sender.ClientMessage("Fast Teams:"@bFastTeams);
	}
	else if (bFastTeams && MutateString ~= "FixTeams")
		MakeTeamsEven(Sender);
	else if (bFastTeams && MutateString ~= "NextTeam")
		NextTeam(Sender);
	else if (bFastTeams && Left(MutateString, 11) ~= "ChangeTeam")
		SetTeam(Sender, Mid(MutateString, 12));
	else if (MutateString ~= "EnablePure")
	{
		if (Sender.bAdmin)
		{
			Default.bUTPureEnabled = True;
			StaticSaveConfig();
			Sender.ClientMessage("UTPure will be ENABLED after next map change!");
		}
		else
			Sender.ClientMessage("Not allowed - Log in as admin!");
	}
	else if (MutateString ~= "DisablePure")
	{
		if (Sender.bAdmin)
		{
			Default.bUTPureEnabled = False;
			StaticSaveConfig();
			Sender.ClientMessage("UTPure will be DISABLED after next map change!");
		}
		else
			Sender.ClientMessage("Not allowed - Log in as admin!");
	}
	else if (MutateString ~= "EnableHitSounds")
	{
		if (Sender.bAdmin)
		{
			bHitSounds = True;
			SaveConfig();
			Level.Game.BroadCastMessage(Sender.PlayerReplicationInfo.PlayerName@"enabled Hit Sounds!");
			if (bbPlayer(Sender) != None)
				bbPlayer(Sender).zzbNoHitSounds = False;
		}
		else
		{
			if (bHitSounds && bbPlayer(Sender) != None)
			{
				Sender.ClientMessage("Enabling Hit Sounds for you!");
				bbPlayer(Sender).zzbNoHitSounds = False;
			}
			else
				Sender.ClientMessage("Denied - HitSounds are disabled. Log in as admin to enable!");
		}
	}
	else if (MutateString ~= "DisableHitSounds")
	{
		if (Sender.bAdmin)
		{
			bHitSounds = False;
			SaveConfig();
			Level.Game.BroadCastMessage(Sender.PlayerReplicationInfo.PlayerName@"turned off Hit Sounds!");
		}
		else
		{
			if (bHitSounds && bbPlayer(Sender) != None)
			{
				Sender.ClientMessage("Disabling HitSounds for you!");
				bbPlayer(Sender).zzbNoHitSounds = True;
			}
			else
				Sender.ClientMessage("Denied - HitSounds are enabled. Log in as admin to disable!");
		}
	}
	else if (MutateString ~= "PureShowIPs")
	{
		if (Sender.bAdmin)
		{
			for (zzP = Level.PawnList; zzP != None; zzP = zzP.NextPawn)
			{
				zzPP = PlayerPawn(zzP);
				if (zzPP != None)
				{
					zzs = zzPP.GetPlayerNetworkAddress();
					zzs = Left(zzs,InStr(zzs,":"));
					Sender.ClientMessage(zzPP.PlayerReplicationInfo.PlayerName@"-"@zzs);
				}
			}
		}
		else
			Sender.ClientMessage("ShowIPs denied - Log in as admin!");
	}
	else if (MutateString ~= "PureShowTickrate")
	{
		Sender.ClientMessage("Server Tickrate is set at"@Sender.ConsoleCommand("get IpDrv.TcpNetDriver NetServerMaxTickRate")$".");
	}
	else if (MutateString ~= "PureShowNetspeeds")
	{
		for (zzP = Level.PawnList; zzP != None; zzP = zzP.NextPawn)
		{
			zzbbPP = bbPlayer(zzP);
			if (zzbbPP != None)
			{
				Sender.ClientMessage(zzbbPP.PlayerReplicationInfo.PlayerName@"-"@zzbbPP.zzNetspeed);
			}
		}

	}
	else if (MutateString ~= "ShowID" || MutateString ~= "ShowIDs")
	{
		if (Sender.bAdmin)
		{
			Sender.ClientMessage("------- ID List -------");
			for (zzP = Level.PawnList; zzP != None; zzP = zzP.NextPawn)
			{
				zzPP = PlayerPawn(zzP);
				if (zzPP != None && zzPP.bIsPlayer && NetConnection(zzPP.Player) != None)
				{
					zzPRI = zzPP.PlayerReplicationInfo;
					Sender.ClientMessage("ID:"$zzPRI.PlayerID@":"@zzPRI.PlayerName);
				}
			}
			Sender.ClientMessage("-----------------------");
		}
		else
			Sender.ClientMessage("This function is not available! - Log in as admin!");
	}
	else if (Left(Caps(MutateString),7) == "KICKID ")
	{
		zzi = int(Mid(MutateString,7));
		if (Sender.bAdmin)
		{
			for (zzP = Level.PawnList; zzP != None; zzP = zzP.NextPawn)
			{
				if (zzP.PlayerReplicationInfo.PlayerID == zzi)
				{
					Sender.ClientMessage(zzP.PlayerReplicationInfo.PlayerName@"has been removed from the server!");
					Sender.Kick(zzP.PlayerReplicationInfo.PlayerName);
					zzb = True;
					break;
				}
			}
			if (!zzb)
			{
				Sender.ClientMessage("Failed to find Player with ID"@zzi);
			}

		}
		else
			Sender.ClientMessage("This function is not available! - Log in as admin!");
	}
	else if (Left(Caps(MutateString),6) == "BANID ")
	{
		zzi = int(Mid(MutateString,6));
		if (Sender.bAdmin)
		{
			for (zzP = Level.PawnList; zzP != None; zzP = zzP.NextPawn)
			{
				if (zzP.PlayerReplicationInfo.PlayerID == zzi)
				{
					Sender.ClientMessage(zzP.PlayerReplicationInfo.PlayerName@"has been banned and removed from the server!");
					Sender.KickBan(zzP.PlayerReplicationInfo.PlayerName);
					zzb = True;
					break;
				}
			}
			if (!zzb)
			{
				Sender.ClientMessage("Failed to find Player with ID"@zzi);
			}

		}
		else
			Sender.ClientMessage("This function is not available! - Log in as admin!");
	}
	   
	if ( NextMutator != None )
		NextMutator.Mutate(MutateString, Sender);

} // Process the mutate commands


// ==================================================================================
// NextTeam - Allow a player to switch team (DB Request)
// ==================================================================================
// This is where i would like to put my personal contribution to the project. See
// it as the big brother of EZTeams. 

function NextTeam(PlayerPawn zzp)
{
	local int nWantedTeam;
	local TeamGamePlus tgp;
	local float zzOldTeam;

	if (Level.Game.bTeamGame && Level.Game.IsA('TeamGamePlus')
			 && (((Level.TimeSeconds - zzTeamChangeTime) > 60) || (!xxGameIsPlaying() && (Level.TimeSeconds - zzTeamChangeTime) > 5)))
	{
		tgp = TeamGamePlus(Level.Game);
		zzOldTeam = zzp.PlayerReplicationInfo.Team;
		nWantedTeam = zzOldTeam + 1;

		if (nWantedTeam >= tgp.MaxTeams)
			nWantedTeam = 0;
			
		zzp.ChangeTeam(nWantedTeam);
		if (zzp.PlayerReplicationInfo.Team != zzOldTeam)
		{
			// View from self if changing team is valid 
			if (zzp.ViewTarget != None)
			{
				zzp.bBehindView = false;
				zzp.ViewTarget = None;
			}
			zzTeamChangeTime = Level.TimeSeconds;
		}
	}
}

// ==================================================================================
// MakeTeamsEven - Switch player from team if teams are uneven. (DB Request)
// ==================================================================================
// This is where i would like to put my personal contribution to the project. See
// it as the big brother of EZTeams. I will put code if allowed to.
// 
function MakeTeamsEven(PlayerPawn zzp)
{
	local int zzOldTeam, lowTeam, i, lowTeamSize;
	local TeamGamePlus tgp;

	// Start by checking if fix is needed base on gametype
	if (Level.Game.IsA('TeamGamePlus') && Level.Game.bTeamGame)
	{
		tgp = TeamGamePlus(Level.Game);

		lowTeamSize = 128;
		for (i = 0; i<tgp.MaxTeams; i++)
		{
			if (tgp.Teams[i].Size < lowTeamSize)
			{
				lowTeamSize = tgp.Teams[i].Size;
				lowTeam = i;
			}
		}

		zzOldTeam = zzp.PlayerReplicationInfo.Team;
		if ((tgp.Teams[zzOldTeam].Size - lowTeamSize) < 2)
			return;
		
		Level.Game.ChangeTeam(zzp, lowTeam);
		if (zzp.PlayerReplicationInfo.Team != zzOldTeam )
		{
			// @@TODO : Handling of warshell ?
			if (zzp.ViewTarget != None)
			{
				zzp.bBehindView = false;
				zzp.ViewTarget = None;
			}
			// Use our own implementation of died
			xxDied(zzp);
			zzTeamChangeTime = Level.TimeSeconds;
		}
	}
}

function SetTeam(PlayerPawn zzp, string zzsteam)
{
	local bool zzbvalid;
	local int zzOldTeam, zzteam;

	if (Level.Game.bTeamGame && Level.Game.IsA('TeamGamePlus')
			 && (((Level.TimeSeconds - zzTeamChangeTime) > 60) || (!xxGameIsPlaying() && (Level.TimeSeconds - zzTeamChangeTime) > 5)))
	{
		zzbvalid = true;
		if (zzsteam ~= "red" || zzsteam ~= "0")
			zzteam = 0;
		else if (zzsteam ~="blue" || zzsteam ~= "1")
			zzteam = 1;
		else if (zzsteam ~="green" || zzsteam ~= "2")
			zzteam = 2;
		else if (zzsteam ~="gold" || zzsteam ~= "3")
			zzteam = 3;
		else
			zzbvalid = false;
		
		if (!zzbvalid && zzteam >= TeamGamePlus(Level.Game).MaxTeams)
			zzbvalid = false;
		
		if (!zzbvalid)
		{
			zzp.ClientMessage("Wrong team selected : "$zzsteam);
			return;
		}

		// Ok .. chosen a good team
		zzOldTeam = zzp.PlayerReplicationInfo.Team;
		zzp.ChangeTeam(zzteam);
		if (zzp.PlayerReplicationInfo.Team != zzOldTeam)
		{
			// View from self if changing team is valid 
			if (zzp.ViewTarget != None)
			{
				zzp.bBehindView = false;
				zzp.ViewTarget = None;
			}
			zzTeamChangeTime = Level.TimeSeconds;
		}
	}
}

// This is my own version of Died used when player makes teams even,
// Using xxDies() will just report a team change but no suicide to ngStats.
function xxDied(pawn zzp)
{
	local pawn zzOtherPawn;
	local actor zzA;

	if (xxGameIsPlaying())
	{		
		zzp.Health = Min(0, zzp.Health);
		for ( zzOtherPawn=Level.PawnList; zzOtherPawn!=None; zzOtherPawn=zzOtherPawn.nextPawn )
			zzOtherPawn.Killed(zzp, zzp, '');
	
		if( zzp.Event != '' )
			foreach AllActors( class 'Actor', zzA, zzp.Event )
				zzA.Trigger( zzp, None );
			
		// Stop any spree's players had
		zzp.Spree = 0;
		
		// Make sure flag is dropped
		if (zzp.PlayerReplicationInfo.HasFlag != None)
			CTFFlag(zzp.PlayerReplicationInfo.HasFlag).Drop(0.5 * zzp.Velocity);

		// Discard all inventory
		Level.Game.DiscardInventory(zzp);
		
		Velocity.Z *= 1.3;
		if ( zzp.Gibbed('Suicided') )
		{
			zzp.SpawnGibbedCarcass();
			zzp.HidePlayer();
		}
		zzp.PlayDying('Suicided', zzp.Location);

		if ( zzp.RemoteRole == ROLE_AutonomousProxy )
			zzp.ClientDying('Suicided', zzp.Location);
		
		zzp.GotoState('Dying');
	}
}

// ==================================================================================
// GameIsPlaying - Tells if game is currently in progress
// ==================================================================================
function bool xxGameIsPlaying()
{
	local DeathMatchPlus DMP;

	// Determine if match has started or ended (server side only) 
	// should i assume DMP be default for net games ?
	if (Level.Game.IsA('DeathMatchPlus'))
	{
		DMP = DeathMatchPlus(Level.Game); 
		if (DMP.bGameEnded || (DMP.bRequireReady && (DMP.CountDown > 0)))
			return false;
	}
	return true;
}

// ==================================================================================
// WaitingForTournament - Tells when game hasnt started yet
// ==================================================================================
function bool xxWaitingForTournament()
{
	local DeathMatchPlus DMP;

	// Determine if match has started or ended (server side only) 
	// should i assume DMP be default for net games ?
	if (Level.Game.IsA('DeathMatchPlus'))
	{
		DMP = DeathMatchPlus(Level.Game); 
		if (DMP.bRequireReady && (DMP.CountDown > 0))
			return true;
	}
	return false;
}

// ==================================================================================
// HandlePickupQuery - Fix the messed up inv touching array before giving an item
// ==================================================================================
function bool HandlePickupQuery(Pawn Other, Inventory item, out byte bAllowPickup)
{
	local bool bValid;
	local int i;
	local Inventory belt, pads, armor;

	bValid = false;
	for (i = 0; i<4; i++)
	{
		if (Other.Touching[i] == item)
			bValid=true;
	}
	if (!bValid)
		return false;

	if (item.IsA('UT_ShieldBelt'))
	{
		item.Default.Charge=150;
	}
	else if (item.IsA('Armor2') || item.IsA('ThighPads'))
	{
		belt = Other.FindInventoryType(class'UT_ShieldBelt');
		if (belt != None)
		{
			belt.Default.Charge = 150;
			pads = Other.FindInventoryType(class'ThighPads');
			armor = Other.FindInventoryType(class'Armor2');
		
			// Only care if Belt+Pads are present
			if (item.IsA('Armor2') && pads != None)
				belt.Default.Charge = 150 - pads.charge;
			else if (item.IsA('ThighPads') && armor != None)
				belt.Default.Charge = 150 - armor.charge;
		}
	}	
	return super.HandlePickupQuery(Other, item, bAllowPickup);
}

static function xxLog(coerce string s)
{
	Log(s, 'UTPure');
}

/////////////////////////////////////////////////////////
// UCRC (OBJ LINKERS) Code.
// Handles OBJ checking
/////////////////////////////////////////////////////////

function xxOBJCheck(bbPlayer zzPlayer, string zzPiece, bool zzbFinal)
{
	local OLT zzOBJT;
	local string zzType;
	local int zzx;
	local bool zzb;

	zzType = xxCheckPackage(zzPiece, zzOBJT);
	for (zzx = 0; zzx < zzOKOBJCount; zzx++)
	{
		if (zzOBJT.zzName ~= zzOKOBJ[zzx].zzName)
		{
			zzb = True;
			if (xxCompareOBJT(zzOBJT,zzOKOBJ[zzx]))
			{
				zzPlayer.zzOBJOK[zzx]++;
			}
			else
			{
				xxLog(zzPlayer.PlayerReplicationInfo.PlayerName@zzOBJT.zzName@zzOBJT.zzNames@zzOBJT.zzNamesK@zzOBJT.zzImports@zzOBJT.zzImportsK@zzOBJT.zzExports@zzOBJT.zzExportsK@zzOBJT.zzGen@zzOBJT.zzLazy);
				zzPlayer.xxServerCheater(chr(79)$chr(66)@zzOBJT.zzName);	// "ob"
			}
			if (zzOKOBJ[zzx].zzbUTPure)
			{
				xxExtractPath(zzPiece,zzPlayer);
			}
		}
	}

	if (zzbFinal)
	{
		zzb = True;
		for (zzx = 0; zzx < zzOKOBJCount; zzx++)
		{
// 			Log(zzx@zzPlayer.zzOBJOK[zzx]);
			zzb = zzb && (zzPlayer.zzOBJOK[zzx] == 1);
		}
		if (!zzb)
			zzPlayer.xxServerCheater(chr(79)$chr(67));	// "oc"
		zzPlayer.zzbDidOBJ = zzb;
		Log(zzPlayer.PlayerReplicationInfo.PlayerName@"packages:"@zzPlayer.zzAllPackages,'UTPure');
	}
	else
		zzPlayer.zzAllPackages = zzPlayer.zzAllPackages@zzOBJT.zzName;
}

// 4.32:
// UTPure: xxx Engine 3345 112 60 1 5370 188 14 47
// UTPureCheat: xxx (xx:x) had an impurity (OB Engine)
// UTPure: xxx Botpack 7453 198 1490 40 12393 435 12 3791
// UTPure: xxx UWindow 1406 46 98 2 3423 120 9 30
// UTPure: xxx UWeb 152 4 35 0 156 5 9 0

function xxDoOBJ()
{
	local string zzs,zzType;
	local int zzx;
	local bool zzbLast;
	local OLT zzOBJT;

	xxAddPackage(chr(101)$chr(110)$chr(103)$chr(105)$chr(110)$chr(101),3348,112,60,1,5370,188,17,47,1); // "engine"
	xxAddPackage(chr(98)$chr(111)$chr(116)$chr(112)$chr(97)$chr(99)$chr(107),7625,194,1490,40,12695,446,14,3806,0); // "botpack"
	xxAddPackage(chr(117)$chr(119)$chr(105)$chr(110)$chr(100)$chr(111)$chr(119),1407,46,98,2,3423,120,10,24,0); // "uwindow"
	xxAddPackage(chr(117)$chr(119)$chr(101)$chr(98),153,4,35,0,156,5,10,0,0); // "uweb"

	zzs = ConsoleCommand(zzOBJLINKERS);
	
	while (True)
	{
		zzx = InStr(zzs,zzOBJSearch);
		zzbLast = zzx == -1;
		if (zzbLast)
			break;
		zzType = xxCheckPackage(Left(zzs,zzx++), zzOBJT);
//		Log(zzType);
		switch(xxImportantPackage(zzOBJT, zzType))
		{
			Case 2:	zzOBJT.zzbUTPure = True;
			Case 1:	zzOKOBJ[zzOKOBJCount++] = zzOBJT;
			Case 0: break;
		}
		zzs = Mid(zzs,zzx);
	}
}

function bool xxCompareOBJT(OLT zzO1, OLT zzO2)
{
/*	Log("Compare:");
	Log(zzO1.zzName@zzO2.zzName);
	Log(zzO1.zzNames@zzO2.zzNames);
	Log(zzO1.zzNamesK@zzO2.zzNamesK);
	Log(zzO1.zzImports@zzO2.zzImports);
	Log(zzO1.zzImportsK@zzO2.zzImportsK);
	Log(zzO1.zzExports@zzO2.zzExports);
	Log(zzO1.zzExportsK@zzO2.zzExportsK);
	Log(zzO1.zzGen@zzO2.zzGen);
	Log(zzO1.zzLazy@zzO2.zzLazy);*/

	return	(
		 (( zzO1.zzNames == zzO2.zzNames && zzO1.zzGen == zzO2.zzGen) ||
		  ( zzO1.zzNames == (zzO2.zzNames + zzO2.zzAlt) && zzO1.zzGen == (zzO2.zzGen + zzO2.zzAlt) )
		 ) &&
		zzO1.zzImports == zzO2.zzImports &&
		zzO1.zzExports == zzO2.zzExports
		);
}

function xxAddPackage(string zzName, int zzNames, int zzNamesK, int zzImports, int zzImportsK, int zzExports, int zzExportsK, int zzGen, int zzLazy, int zzAlt)
{
	zzOKOBJ[zzOKOBJCount].zzName = zzName;
	zzOKOBJ[zzOKOBJCount].zzNames = zzNames;
	zzOKOBJ[zzOKOBJCount].zzNamesK = zzNamesK;
	zzOKOBJ[zzOKOBJCount].zzImports = zzImports;
	zzOKOBJ[zzOKOBJCount].zzImportsK = zzImportsK;
	zzOKOBJ[zzOKOBJCount].zzExports = zzExports;
	zzOKOBJ[zzOKOBJCount].zzExportsK = zzExportsK;
	zzOKOBJ[zzOKOBJCount].zzGen = zzGen;
	zzOKOBJ[zzOKOBJCount].zzLazy = zzLazy;
	zzOKOBJ[zzOKOBJCount].zzAlt = zzAlt;
	zzOKOBJCount++;
}

function int xxImportantPackage(OLT zzOBJT, string zzType)
{
	if (zzType ~= "unr")	// Always add map
		return 1;
	if (zzOBJT.zzName ~= ("vahandler"$ThisVer))
		return 1;
	if (zzOBJT.zzName ~= ("zppure"$ThisVer))
		return 1;
	if (zzOBJT.zzName ~= ("bp1handler"$ThisVer))
		return 1;
	if (zzOBJT.zzName ~= ("bp4handler"$ThisVer))
		return 1;
	if (zzOBJT.zzName ~= (VersionStr$ThisVer))
		return 2;
	return 0;
}

function string xxCheckPackage(string zzPack, out OLT zzOBJT)
{
//ScriptLog: Piece unr (Package dm-liandri): Names=1743 (6K/51K) Imports=146 (3K) Exports=1488 (52K) Gen=1 Lazy=1../Textures/UTtech2
//struct zzOBJListType {
//	var string zzName;
//	var int zzNames, zzNamesK, zzImports, zzImportsK, zzExports, zzExportsK, zzGen, zzLazy;
//};

	local string zzs;
	local string zzType;
	local int zzi;
	
//	Log(zzPack);
	zzOBJT.zzbUTPure = False;

	// Get type (u, utx, unr, uax, umx, ?)
	zzi = InStr(zzPack," ");
	zzType = Left(zzPack,zzi);
	zzPack = Mid(zzPack,zzi+1);
	zzi = InStr(zzType,".u");
	zzType = Mid(zzType,zzi+1);

	// Get up to front of package name
	zzi = InStr(zzPack," ");
	zzPack = Mid(zzPack,zzi+1);

	// Get package name
	zzi = InStr(zzPack,")");
	zzOBJT.zzName = Left(zzPack,zzi);

	// Here comes Names=
	zzi = InStr(zzPack,"=");
	zzPack = Mid(zzPack,zzi+1);
	zzi = InStr(zzPack," ");
	zzOBJT.zzNames = int(Left(zzPack,zzi));

	// The NamesK (xk/51k)
	zzi = InStr(zzPack,"/");
	zzPack = Mid(zzPack,zzi+1);
	zzi = InStr(zzPack,"K");
	zzOBJT.zzNamesK = int(Left(zzPack,zzi));

	// Imports
	zzi = InStr(zzPack,"=");
	zzPack = Mid(zzPack,zzi+1);
	zzi = InStr(zzPack," ");
	zzOBJT.zzImports = int(Left(zzPack,zzi));

	// ImportsK
	zzi = InStr(zzPack,"(");
	zzPack = Mid(zzPack,zzi+1);
	zzi = InStr(zzPack,"K");
	zzOBJT.zzImportsK = int(Left(zzPack,zzi));

	// Exports
	zzi = InStr(zzPack,"=");
	zzPack = Mid(zzPack,zzi+1);
	zzi = InStr(zzPack," ");
	zzOBJT.zzExports = int(Left(zzPack,zzi));

	// ExportsK
	zzi = InStr(zzPack,"(");
	zzPack = Mid(zzPack,zzi+1);
	zzi = InStr(zzPack,"K");
	zzOBJT.zzExportsK = int(Left(zzPack,zzi));

	// Gen
	zzi = InStr(zzPack,"=");
	zzPack = Mid(zzPack,zzi+1);
	zzi = InStr(zzPack," ");
	zzOBJT.zzGen = int(Left(zzPack,zzi));
/*
	// Lazy
	zzi = InStr(zzPack,"=");
	zzPack = Mid(zzPack,zzi+1);
	for (zzi = 1; zzi < Len(zzPack); zzi++)
		if (int(Left(zzPack,zzi)) == 0)
			break;
	zzOBJT.zzLazy = int(Left(zzPack,zzi-1));
*/
//	Log("OLT"@zzOBJT.zzName@zzOBJT.zzNames@zzOBJT.zzNamesK@zzOBJT.zzImports@zzOBJT.zzImportsK@zzOBJT.zzExports@zzOBJT.zzExportsK@zzOBJT.zzGen@zzOBJT.zzLazy);
	return zzType;
}

function xxExtractPath(string zzPiece, bbPlayer zzPlayer)
{
	local int zzx;
	local string zzs;

//	Log("ePath:"@zzPiece);

	zzx = InStr(zzPiece,"=")+1;
	while (true)
	{
		zzs = Mid(zzPiece,zzx,1);
		if (int(zzs) == 0 && zzs != "0")
			break;
		zzx++;
	}
	zzPiece = Mid(zzPiece,zzx);
	zzx = InStr(zzPiece," ");
	zzPiece = Left(zzPiece,zzx);
	zzx = InStr(zzPiece,VersionStr$ThisVer);
//	Log("x4="@zzx);
	if (zzx == -1)
		zzx = InStr(zzPiece,zzMyGUID);
//	Log("x5="@zzx);
	if (zzx == -1)	//  && Left(zzPiece,1) == ":"
		zzx = InStr(zzPiece,Mid(zzMyGUID,5));
//	Log("x6="@zzx@Mid(zzMyGUID,5));
	zzPlayer.zzCRCPath = Left(zzPiece,zzx-1);
	zzPlayer.zzCRCFile = Mid(zzPiece,zzx);
//	Log("Path:"@zzPlayer.zzCRCPath@zzPlayer.zzCRCFile);
}


/////////////////////////////////////////////////////////
// CRC Handling Code.
// Implemented here as a Dedicated Server needs to run CRC checks on itself
/////////////////////////////////////////////////////////

// xxGetNextPath: Used to search though path list dynamic array. zzPathsList becomes next part. returns the path. zzQuote is "
static function string xxGetNextPath(out string zzPathsList, string zzQuote)
{
	local int zzPos;
	local string zzOutStr;

	zzPos = InStr(zzPathsList,zzQuote);
	zzPathsList = Mid(zzPathsList,zzPos+1);
	zzPos = InStr(zzPathsList,zzQuote);
	zzOutStr = Left(zzPathsList,zzPos);
	zzPathsList = Mid(zzPathsList,zzPos+1);
	return zzOutStr;
}

// returns path name.  zzText becomes utpure*.whatever
static function string xxParsePath(out string zzText, string zzMatch, string zzReplacement)
{
	local int zzPos;
	local string OutStr;
  
	zzPos = InStr(zzText, zzMatch);

	OutStr = Left(zzText, zzPos-1); //mac/linux compatibility??????
	if (zzPos >= 0)
		zzText = zzReplacement $ Mid(zzText, zzPos + Len(zzMatch));
	return OutStr;
}

//xxDoCRC: This is it. The actual CRC controlling function:
static function int xxDoCRC (Actor zzA, out int zzFileSize, int zzInitialCRC, string zzPathsGet,
	string zzmyFileName, string zzGUID, string zzQuote, string zzStar)
{
	local PureMajic zzCRC;
	local string zzPaths, zzNextPath;

	zzCRC = new (None) Class'PureMajic';
	zzCRC.xxMake_CRC_Table();
	zzCRC.zzCurCRC = zzInitialCRC;
	zzPaths = zzA.ConsoleCommand(zzPathsGet);

	while (!zzCRC.zzbDidCRC)
	{
		zzNextPath = xxGetNextPath(zzPaths,zzQuote);
		if (zzNextPath == "")
			break;
		zzCRC.IncludePath = xxParsePath(zzNextPath,zzStar,zzmyFileName);  //is this safe?
		zzCRC.IncludeBinaryFile(zzNextPath);
	}

	zzFileSize = zzCRC.zzFileSize;

	if (UTPure(zzA) != None)
		UTPure(zzA).zzMyGUID = zzCRC.zzFileGUID;

	return zzCRC.zzCurCRC;
}
/*
function string xxRandomFileName()
{
	local string zzRL,zzResult;
	local int zzi;

	zzRL = "abcdefghijklmnopqrstuvwxyz0123456789";
	zzi = Len(zzRL);

	zzResult = "Pure"$Mid(zzRL,rand(zzi),1)$Mid(zzRL,rand(zzi),1)$Mid(zzRL,rand(zzi),1)$Mid(zzRL,rand(zzi),1)$".u";

	return zzResult;
}
*/
event Destroyed()	// Make sure config is stored.
{
	SaveConfig();
	Super.Destroyed();
}

defaultproperties
{
	VersionStr="UTPureRC"
	LongVersion="Release Candidate "
	ThisVer="6A"
	bUTPureEnabled=True
	bAlwaysTick=True
	bHitSounds=False
}
